//+------------------------------------------------------------------+
//|                                              TradeControl_en.mq5 |
//|                                             Copyright KlimMalgin |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "KlimMalgin"
#property link      ""
#property version   "1.00"


datetime start_date = 0;   // Data, do qual o histrico comecou a ser lido

int OrdersPrev = 0;        // Nmero de ordens  no momento da chamada anterior da OnTrade()
int PositionsPrev = 0;     // Nmero de posies no momento da chamada anterior da OnTrade()
ulong LastOrderTicket = 0; // Ingresso da ltima ordem processada

int _GetLastError=0;       // Erro no cdigo
long state=0;              // Estado da ordem

/*
 *
 * Estrutura que armazena informaes sobre as posioes
 *
 */
struct _position
{

long     type,          // Tipo de posio
         magic;         // Nmero mgico para a posio
datetime time;          // Hora da abertuda de posio

double   volume,        // Volume da posio
         priceopen,     // Preo da posio
         sl,            // Nvel de Stop Loss para a posio em aberto
         tp,            // Nvel de Take Profit da posio em aberto
         pricecurrent,  // Preo atual do smbolo
         comission,     // Comisso
         swap,          // Swap acumulado
         profit;        // Lucro atual

string   symbol,        // Smbolo, pelo qual foi aberta a posio
         comment;       // Comentrio da posio
};

int _ExpertPositionsTotal = 0;

_position PositionList[],  // Array que armazena informaes sobre a posio
      PrevPositionList[];


/*
 *
 * Estrutura que armazena infomaes sobre ordens
 *
 */
struct _orders
{

datetime time_setup,       // hora da colocao de ordem
         time_expiration,  // hora da expirao da ordem
         time_done;        // hora da execuo ou cancelamento da ordem
         
long     type,             // Tipo de ordem
         state,            // Estado da ordem
         type_filling,     // tipo de execuo por lembrana
         type_time,        // tempo de vida da ordem
         ticket;           // ingresso da ordem
         
long     magic,            // ID do Expert Advisor, que colocou a ordem 
                           // (destinado a garantir que cada Expert 
                           // deve colocar o seu prprio nmero nico)
                           
         position_id;      // ID posio, que  colocado na ordem, 
                           // Quando ele  executado. Cada ordem executada invoca uma 
                           // negcio, que abre novas ou altera poses 
                           // existentes. O ID de posio le colocado 
                           // no momento em que a ordem foi executada.
                           
double volume_initial,     // volume inicial para colocar um ordem
       volume_current,     // volume sem preencher
       price_open,         // preo, especificado na ordem
       sl,                 // nvel de Stop Loss
       tp,                 // nvel de Take Profit
       price_current,      // Preo atual pela smbolo da ordem
       price_stoplimit;    // Preo de colocao de ordem limite quando StopLimit ordem  acionada
       
string symbol,             // smbolo, pelo qual foi colocada a ordem
       comment;            // Comentrio
                           
};

int _ExpertOrdersTotal = 0;

_orders OrderList[],       // Arrays que armazenam informaes de ordens
        PrevOrderList[];

//+------------------------------------------------------------------+
//| Funo Expert de inicializao                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
start_date = 0;

OrdersPrev = OrdersTotal();
PositionsPrev = PositionsTotal();

GetPosition(PrevPositionList);
GetOrders(PrevOrderList);
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Funo Expert de desinicializao                                |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Funo OnTrade                                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---
GetPosition(PositionList);
GetOrders(OrderList);
datetime dc = TimeCurrent();
HistorySelect(start_date,dc);


Alert("O evento Trade ocorreu");

if (OrdersPrev < OrdersTotal())
{
   OrderGetTicket(OrdersTotal()-1);// Selecione a ltima ordem para trabalhar com ela
   _GetLastError=GetLastError();
   Print("Erro #",_GetLastError);ResetLastError();
   //--
   if (OrderGetInteger(ORDER_STATE) == ORDER_STATE_STARTED)
   {
      Alert(OrderGetTicket(OrdersTotal()-1),"A ordem chegou para processamento");
      LastOrderTicket = OrderGetTicket(OrdersTotal()-1);    // Salvando o ingresso da ordem para trabalhos futuros
   }
   
   
   state = OrderGetInteger(ORDER_STATE);
   if (state == ORDER_STATE_PLACED)
   {
      switch(OrderGetInteger(ORDER_TYPE))
      {
         case 2:
            Alert("Ordem pendente Buy Limit #", OrderGetTicket(OrdersTotal()-1)," aceita!");
         break;
         
         case 3:
            Alert("Ordem pendente Sell Limit #", OrderGetTicket(OrdersTotal()-1)," aceita!");
         break;
         
         case 4:
            Alert("Ordem pendente Buy Stop #", OrderGetTicket(OrdersTotal()-1)," aceita!");
         break;
         
         case 5:
            Alert("Ordem pendente Sell Stop #", OrderGetTicket(OrdersTotal()-1)," aceita!");
         break;
         
         case 6:
            Alert("Ordem pendente Buy Stop Limit #", OrderGetTicket(OrdersTotal()-1)," aceita!");
         break;
                 
         case 7:
            Alert("Ordem pendente Sell Stop Limit #", OrderGetTicket(OrdersTotal()-1)," aceita!");
         break;         
      }
      
   }
   
   
   
}
else if(OrdersPrev > OrdersTotal())
{
   state = HistoryOrderGetInteger(LastOrderTicket,ORDER_STATE);

   // Se a ordem no for encontrado, gerar um erro
   _GetLastError=GetLastError();
   if (_GetLastError != 0){Alert("Erro #",_GetLastError," ordem no encontrada!");LastOrderTicket = 0;}
   Print("Erro #",_GetLastError," state: ",state);ResetLastError();

   // Se a ordem foi totalmente executada
   if (state == ORDER_STATE_FILLED)
   {
      // Ento analise o ltimo negcio
      // --
      Alert(LastOrderTicket, "Ordem executada, indo para negociao");
      switch(HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_ENTRY))
      {
         
         // Entrando no mercado
         case DEAL_ENTRY_IN:
         Alert(HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_ORDER), 
         " ordem chamou negociao #",HistoryDealGetTicket(HistoryDealsTotal()-1));
         
            switch(HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_TYPE))
            {
               case 0:
               // Se os volumes de posio e de negcio so iguais, ento posio acabou de ser aberta
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) 
                  && (PositionGetDouble(POSITION_VOLUME) == HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_VOLUME)))
                  {
                     Alert("Posio de compra foi aberta no par ", 
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)); 
                  }
                  else
               // Se os volumes de posio e acordo no so iguais, houve aumento da posio
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) 
                  && (PositionGetDouble(POSITION_VOLUME) > HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_VOLUME)))
                  {
                     Alert("Houve aumento da posio de compra no par ", 
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)); 
                  }
               break;
               
               case 1:
               // Se os volumes de posio e de negcio so iguais, ento posio acabou de ser aberta
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) 
                  && (PositionGetDouble(POSITION_VOLUME) == HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_VOLUME)))
                  {
                     Alert("Posio de venda foi aberta no par ", 
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)); 
                  }
                  else
               // Se os volumes de posio e acordo no so iguais, houve aumento da posio
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) 
                  && (PositionGetDouble(POSITION_VOLUME) > HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_VOLUME)))
                  {
                     Alert("Houve aumento da posio de venda no par ", 
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)); 
                  }
                  
               break;
               
               default:
                  Alert("Tipo de cdigo no processado ",
                        HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_TYPE));
               break;
            }
         break;
         
         // Saindo do mercado
         case DEAL_ENTRY_OUT:
         Alert(HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_ORDER), 
         " ordem chamou negociao #",HistoryDealGetTicket(HistoryDealsTotal()-1));
         
            switch(HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_TYPE))
            {
               case 0:
               // Se a posio, que tentamos fechar, ainda estiver em aberto, entao, ns fechamos apenas parte dela
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) == true)
                  {
                     Alert("Parte da posio de venda foi fechada no par ", 
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL),
                           " com lucro = ",
                           HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_PROFIT));
                  }
                  else
               // Se a posio nao foi encontrada, ento, ela foi fechada totalmente
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) == false)
                  {
                     Alert("Posio de venda foi fechada no par ",
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL),
                           " com lucro = ",
                           HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_PROFIT));
                  }
               break;
               
               case 1:
               // Se a posio, que tentamos fechar, ainda estiver em aberto, entao, ns fechamos apenas parte dela
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) == true)
                  {
                     Alert("Parte da posio de compra foi fechada no par ", 
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL),
                           " com lucro = ",
                           HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_PROFIT));
                  }
                  else
               // Se a posio nao foi encontrada, ento, ela foi fechada totalmente
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) == false)
                  {
                     Alert("Posio de compra foi fechada no par ",
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL),
                           " com lucro = ",
                           HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_PROFIT));
                  }
                  
               break;
               
               default:
                  Alert("Tipo de cdigo no processado ",
                        HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_TYPE));
               break;
            }
         break;
         
         // Reverso
         case DEAL_ENTRY_INOUT:
         Alert(HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_ORDER), 
         " ordem chamou negociao #",HistoryDealGetTicket(HistoryDealsTotal()-1));
         
            switch(HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_TYPE))
            {
               case 0:
                  Alert("Venda revertida para compra no par ",
                        HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL),
                        " com lucro = ",
                        HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_PROFIT)); 
               break;
               
               case 1:
                  Alert("Compra revertida no par ",
                        HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL),
                        " com lucro = ",
                        HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_PROFIT)); 
               break;
               
               default:
                  Alert("Tipo de cdigo no processado ",
                        HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_TYPE));
               break;
            }
         break;
         
         // Indica o registro de estado
         case DEAL_ENTRY_STATE:
            Alert("Indica o registro de estado. Tipo de cdigo no processado ", 
            HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_TYPE));
         break;
      }
      // --
   }
}


if ((PositionsPrev == PositionsTotal()) && (OrdersPrev == OrdersTotal()))
{
   string _alerts = "";
   bool modify = false;
   
   for (int i=0;i<_ExpertPositionsTotal;i++)
   {
      if (PrevPositionList[i].sl != PositionList[i].sl)
      {
         _alerts += "No par "+PositionList[i].symbol+" Stop Loss foi alterado de "+ PrevPositionList[i].sl +" para "+ PositionList[i].sl +"\n";
         modify = true;
      }
      if (PrevPositionList[i].tp != PositionList[i].tp)
      {
         _alerts += "No par "+PositionList[i].symbol+" Take Profit foi alterado de "+ PrevPositionList[i].tp +" para "+ PositionList[i].tp +"\n";
         modify = true;
      }
      
   }
   
   for (int i = 0;i<_ExpertOrdersTotal;i++)
   {
      if (PrevOrderList[i].sl != OrderList[i].sl)
      {
         _alerts += "Ordem "+OrderList[i].ticket+" de Stop Loss foi alterada de "+ PrevOrderList[i].sl +" para "+ OrderList[i].sl +"\n";
         modify = true;
      }
      if (PrevOrderList[i].tp != OrderList[i].tp)
      {
         _alerts += "Ordem "+OrderList[i].ticket+" de Take Profit foi alterado de "+ PrevOrderList[i].tp +" para "+ OrderList[i].tp +"\n";
         modify = true;
      }
   }
   
   if (modify == true)
   {
      Alert(_alerts);
      modify = false;
   }
}


GetPosition(PrevPositionList);
GetOrders(PrevOrderList);
OrdersPrev = OrdersTotal();
PositionsPrev = PositionsTotal();

//---
  }
//+------------------------------------------------------------------+
//| Funo tick do Expert                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+



void GetPosition(_position &Array[])
  {
   int _GetLastError=0,_PositionsTotal=PositionsTotal();

   int temp_value=(int)MathMax(_PositionsTotal,1);
   ArrayResize(Array, temp_value);

   _ExpertPositionsTotal=0;
   for(int z=_PositionsTotal-1; z>=0; z--)
     {
      if(!PositionSelect(PositionGetSymbol(z)))
        {
         _GetLastError=GetLastError();
         Print("OrderSelect() - Erro #",_GetLastError);
         continue;
        }
      else
        {
            // se a posio foi encontrada, coloque suas informaes no array
            Array[z].type         = PositionGetInteger(POSITION_TYPE);
            Array[z].time         = PositionGetInteger(POSITION_TIME);
            Array[z].magic        = PositionGetInteger(POSITION_MAGIC);
            Array[z].volume       = PositionGetDouble(POSITION_VOLUME);
            Array[z].priceopen    = PositionGetDouble(POSITION_PRICE_OPEN);
            Array[z].sl           = PositionGetDouble(POSITION_SL);
            Array[z].tp           = PositionGetDouble(POSITION_TP);
            Array[z].pricecurrent = PositionGetDouble(POSITION_PRICE_CURRENT);
            Array[z].comission    = PositionGetDouble(POSITION_COMMISSION);
            Array[z].swap         = PositionGetDouble(POSITION_SWAP);
            Array[z].profit       = PositionGetDouble(POSITION_PROFIT);
            Array[z].symbol       = PositionGetString(POSITION_SYMBOL);
            Array[z].comment      = PositionGetString(POSITION_COMMENT);
        _ExpertPositionsTotal++;
        }
     }

   temp_value=(int)MathMax(_ExpertPositionsTotal,1);
   ArrayResize(Array,temp_value);
  }
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| Funo GetOrders()                                               |
//+------------------------------------------------------------------+
void GetOrders(_orders &OrdersList[])
  {
   
   int _GetLastError=0,_OrdersTotal=OrdersTotal();

   int temp_value=(int)MathMax(_OrdersTotal,1);
   ArrayResize(OrdersList,temp_value);

   _ExpertOrdersTotal=0;
   for(int z=_OrdersTotal-1; z>=0; z--)
     {
      if(!OrderGetTicket(z))
        {
         _GetLastError=GetLastError();
         Print("GetOrders() - Error #",_GetLastError);
         continue;
        }
      else
        {
        OrdersList[z].ticket          = OrderGetTicket(z);
        OrdersList[z].time_setup      = OrderGetInteger(ORDER_TIME_SETUP);
        OrdersList[z].time_expiration = OrderGetInteger(ORDER_TIME_EXPIRATION);
        OrdersList[z].time_done       = OrderGetInteger(ORDER_TIME_DONE);
        OrdersList[z].type            = OrderGetInteger(ORDER_TYPE);
        
        OrdersList[z].state           = OrderGetInteger(ORDER_STATE);
        OrdersList[z].type_filling    = OrderGetInteger(ORDER_TYPE_FILLING);
        OrdersList[z].type_time       = OrderGetInteger(ORDER_TYPE_TIME);
        OrdersList[z].magic           = OrderGetInteger(ORDER_MAGIC);
        OrdersList[z].position_id     = OrderGetInteger(ORDER_POSITION_ID);
        
        OrdersList[z].volume_initial  = OrderGetDouble(ORDER_VOLUME_INITIAL);
        OrdersList[z].volume_current  = OrderGetDouble(ORDER_VOLUME_CURRENT);
        OrdersList[z].price_open      = OrderGetDouble(ORDER_PRICE_OPEN);
        OrdersList[z].sl              = OrderGetDouble(ORDER_SL);
        OrdersList[z].tp              = OrderGetDouble(ORDER_TP);
        OrdersList[z].price_current   = OrderGetDouble(ORDER_PRICE_CURRENT);
        OrdersList[z].price_stoplimit = OrderGetDouble(ORDER_PRICE_STOPLIMIT);
        
        OrdersList[z].symbol          = OrderGetString(ORDER_SYMBOL);
        OrdersList[z].comment         = OrderGetString(ORDER_COMMENT);
        
        _ExpertOrdersTotal++;
        }
     }

   temp_value=(int)MathMax(_ExpertOrdersTotal,1);
   ArrayResize(OrdersList,temp_value);

  }
//+------------------------------------------------------------------+